import {select, range, scaleOrdinal, } from 'd3';

const scaleColour = scaleOrdinal();
scaleColour.domain(['apple', 'lemon'])
	         .range(['red', 'yellow']);

export const fruitBowl = (parent, props) => {
  //console.log(fruits);
  const {fruits, height, setSelectedFruit, selectedFruit} = props; //Unpack parameters
  
  parent.selectAll('.bowl')
  			.data([null])
  			.enter()
    		.append('rect')
  				.attr('class', 'bowl')
  				.attr('y', 10)
  				.attr('width', 600)
  				.attr('height', 160)
  				.attr('rx', 50)
  				;
  // <---- Code for Nested Elements
  
  const groups =  parent.selectAll('g').data(fruits, d => d.id);
  const groupsEnter = groups.enter().append('g');
  groupsEnter
           .merge(groups) 
              .attr('transform', (d, i) => `translate(${i * 120 + 60},${height / 5})` ) ; 
  
  groups.exit()
  	    .transition().duration(1000)
  	    .remove();

  groupsEnter
    			 .append('circle')
             .attr('fill', d => scaleColour(d.type))
             .attr('r', 0)
  
           .merge(groups.select('circle')) 
   					 .on('mouseover', d => setSelectedFruit(d.id))
   					 .on('mouseout', () =>  setSelectedFruit(null))
           	 .transition().duration(1000)
  					 .attr('fill',d => scaleColour(d.type))
  					 .attr('stroke-width' , 5)
  					 .attr('stroke', d => {return d.id === selectedFruit ? 'blue' : null})
  					 .attr('r', 50)
             .attr('cx', (d, i) => 0)
  
 					; 
 
  
  groupsEnter
    			 .append('text')
             .attr('y', 100 )
           .merge(groups.select('text'))  
  					 .transition().duration(1000)
    				 .text(d =>d.type)
  					; 
 
 

 };